unit UMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShellApi, DosCommand, Registry, Menus,
  CoolTrayIcon, ExtCtrls, XPMan, SHFolder,
  ShlObj, Winsock, UTextFileStream;

const
  ApplicationName = 'Konfigurtor ZdchovNET';
  Author = 'Ji Hajda';
  HomePage = 'http://www.zdechov.net/';
  Email = 'robie@centrum.cz';
  Version = '1.3';
  ReleaseDate = '4.9.2006';
  Creator = 'Chronosoft';
  RegistryRootKey = HKEY_LOCAL_MACHINE;
  RegistryPath = '\Software\'+Creator+'\Configurator ZdechovNET';
  ChangeLogFile = 'Novinky.txt';
  Licence = 'Copyleft';

  DefaultLogFileName = 'DialLog.txt';
  DiallingServiceName = 'VpnDiallingService';
  DiallingServiceDisplayName = 'VPN Dialling service';

  BrowserHomepage = 'http://centrala.zdechov.net/';
  WorkGroup = 'ZDECHOV';
  DefaultConnectionName = 'ZdchovNET';
  ConnectionHost = 'centrala.zdechov.net';
  MainSharedFolderPath = 'C:\Net';
  MainSharedFolderName = 'Net';
  LocalNetAddr = '192.168.0.0';
  LocalNetMask = '255.255.0.0';

type
  TMainForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Bevel1: TBevel;
    CheckBox4: TCheckBox;
    CoolTrayIcon1: TCoolTrayIcon;
    Button3: TButton;
    PopupMenu1: TPopupMenu;
    Ukonit1: TMenuItem;
    estst1: TMenuItem;
    Nastaven1: TMenuItem;
    CheckBox5: TCheckBox;
    XPManifest1: TXPManifest;
    CheckBox6: TCheckBox;
    Oprogramu1: TMenuItem;
    CheckBox9: TCheckBox;
    Zznamvyten1: TMenuItem;
    OpenDialog1: TOpenDialog;
    VPNpipojen1: TMenuItem;
    Spustit1: TMenuItem;
    Zasavit1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure estst1Click(Sender: TObject);
    procedure Ukonit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Nastaven1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Oprogramu1Click(Sender: TObject);
  private
    procedure LoadOptions;
    procedure SaveOptions;
    function GetCentralaHomepage: Boolean;
    procedure SetCentralaHomepage(const Value: Boolean);
    function GetWorkgroupZdechov: Boolean;
    procedure SetWorkgroupZdechov(const Value: Boolean);
    function GetRunOnSystemStart: Boolean;
    procedure SetRunOnSystemStart(const Value: Boolean);
    function GetShareUnblockFirewall: Boolean;
    procedure SetShareUnblockFirewall(const Value: Boolean);
    function GetNetSharedFolder: Boolean;
    procedure SetNetSharedFolder(const Value: Boolean);
    function GetNetworkDomain: string;
  public
    FirstStart: Boolean;
    HostFilterIndex: Integer;
    PingTimeout: Integer;
    NetworkTestLastUpdate: TDateTime;
    property CentralaHomepage: Boolean read GetCentralaHomepage
      write SetCentralaHomepage;
    property WorkgroupZdechov: Boolean read GetWorkgroupZdechov
      write SetWorkgroupZdechov;
    property RunOnSystemStart: Boolean read GetRunOnSystemStart
      write SetRunOnSystemStart;
    property ShareUnblockFirewall: Boolean read GetShareUnblockFirewall
      write SetShareUnblockFirewall;
    property NetSharedFolder: Boolean read GetNetSharedFolder
      write SetNetSharedFolder;
    property NetworkDomain: string read GetNetworkDomain;

    procedure Init;
  end;

var
  MainForm: TMainForm;

function ApplicationDataFolder: string;
function GetIPFromHost(var HostName, IPaddr, WSAErr: string): Boolean;
function GetComputerNetName: string;
function CommonAppDataPath: string;
procedure ShellLaunch(const S: String);

implementation

uses UNetworkTest, UAboutWindow, ULogExceptions, DateUtils, Math,
  StrUtils, UServiceControl;

{$R *.dfm}

const

  // Share types
  STYPE_ALL = -1;  //note: my const
  STYPE_DISKTREE = 0;
  STYPE_PRINTQ = 1;
  STYPE_DEVICE = 2;
  STYPE_IPC =  3;
  STYPE_SPECIAL = $80000000;

  // Share permission
  ACCESS_READ = 1;
  ACCESS_WRITE = 2;
  ACCESS_CREATE = 4;
  ACCESS_EXEC = 8;
  ACCESS_DELETE = 16;
  ACCESS_ATRIB = 32;
  ACCESS_PERM = 64;
  ACCESS_ALL = ACCESS_READ or ACCESS_WRITE or ACCESS_CREATE or ACCESS_EXEC or
    ACCESS_DELETE or ACCESS_ATRIB or ACCESS_PERM;

type
  TShareInfo2 = record
    shi2_netname : PWideChar;
    shi2_type : DWORD;
    shi2_remark : PWideChar;
    shi2_permissions : DWORD;
    shi2_max_uses : DWORD;
    shi2_current_uses : DWORD;
    shi2_path : PWideChar;
    shi2_passwd : PWideChar;
  end;
  PShareInfo2 = ^TShareInfo2;

procedure NetApiBufferFree(Buf: Pointer) stdcall; external 'netapi32.dll';
function NetShareGetInfo(SeverName, NetName: PWideChar; Level: DWORD;
  Buf: Pointer): LongInt; stdcall; external 'netapi32.dll';
function NetShareDel(ServerName, ShareName : PWideChar; Reserved: DWord):
  LongInt; stdcall; external 'netapi32.dll';
function NetShareAdd(ServerName : PWideChar; Level : DWord;
  Buffer : Pointer; var ParamError :DWord) : Longint; stdcall; external 'netapi32.dll';


function CommonAppDataPath: string;
const
  SHGFP_TYPE_CURRENT = 0;
  MAXPATH = 255;
var
  Path: array [0..MAXPATH] of Char;
begin
  SHGetFolderPath(0, CSIDL_COMMON_APPDATA, 0, SHGFP_TYPE_CURRENT, @Path[0]);
  Result := Path;
end;

function ApplicationDataFolder: string;
begin
  Result := CommonAppDataPath + '\' + Creator + '\' + ApplicationName;
  if not DirectoryExists(Result) then
    ForceDirectories(Result);
end;

procedure ShellLaunch(const S: String);
begin
  ShellExecute(0, 'open', PChar(S), '', '', SW_SHOWNORMAL);
end;

function GetComputerNetName: string;
var
  buffer: array[0..255] of char;
  size: dword;
begin
  size := 256;
  if GetComputerName(buffer, size) then
    Result := buffer
  else
    Result := ''
end;

function TMainForm.GetCentralaHomepage: Boolean;
begin
  with TRegistry.Create do
    try
      RootKey := HKEY_CURRENT_USER;
      OpenKey('\Software\Microsoft\Internet Explorer\Main', True);
      Result := ReadString('Start Page') = BrowserHomepage;
    finally
      Free;
    end;
end;

procedure TMainForm.SetCentralaHomepage(const Value: Boolean);
begin
  with TRegistry.Create do
    try
      RootKey := HKEY_CURRENT_USER;
      OpenKey('\Software\Microsoft\Internet Explorer\Main', True);
      if Value then begin
        WriteString('LastStartPage', ReadString('Start Page'));
        WriteString('Start Page', BrowserHomepage);
      end else WriteString('Start Page', ReadString('LastStartPage'));
    finally
      Free;
    end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  LogExceptions.NazevAplikace := ApplicationName + ' ' + Version;

  CheckBox4.Checked := CentralaHomepage;
  CheckBox5.Checked := WorkgroupZdechov;
  CheckBox6.Checked := ShareUnblockFirewall;
  CheckBox9.Checked := NetSharedFolder;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  CoolTrayIcon1.HideMainForm;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  CentralaHomepage := CheckBox4.Checked;
  WorkgroupZdechov := CheckBox5.Checked;
  ShareUnblockFirewall := CheckBox6.Checked;
  NetSharedFolder := CheckBox9.Checked;

  CoolTrayIcon1.HideMainForm;
  SaveOptions;
end;

function TMainForm.GetWorkgroupZdechov: Boolean;
var
  Command: TDosCommand;
  I: Integer;
  Lines2: TStringList;
begin
  Lines2 := TStringList.Create;
  Result := False;
  Command := TDosCommand.Create(nil);
  with Command do try
    CommandLine := ExtractFilePath(Application.ExeName)+'netdom member \\'+GetComputerNetName+' /query';
    OutputLines := Lines2;
    Execute2;
    for I := 0 to Lines2.Count - 1 do
      if Pos(' ' + Workgroup + '.', Lines2[I]) > 0 then Result := True;
  finally
    Free;
    Lines2.Free;
  end;
end;

procedure TMainForm.SetWorkgroupZdechov(const Value: Boolean);
var
  Command: TDosCommand;
begin
  Command := TDosCommand.Create(nil);
  with Command do try
    if Value then CommandLine := 'netdom member \\'+GetComputerNetName+' /joinworkgroup '+WorkGroup;
    Execute2;
  finally
    Free;
  end;
end;

procedure TMainForm.estst1Click(Sender: TObject);
begin
  NetworkTest.Show;
end;

procedure TMainForm.Ukonit1Click(Sender: TObject);
begin
  Close;
end;

function TMainForm.GetRunOnSystemStart: Boolean;
begin
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run', True);
    Result := ReadString(ApplicationName) = Application.ExeName;
  finally
    Free;
  end;
end;

procedure TMainForm.SetRunOnSystemStart(const Value: Boolean);
begin
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run', True);
    if Value then WriteString(ApplicationName, Application.ExeName)
    else DeleteValue(ApplicationName);
  finally
    Free;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
//  Connecting := False;
  with CoolTrayIcon1 do begin
    HideTaskbarIcon;
    Hint := ApplicationName;
  end;

  LoadOptions;
  Application.ShowMainForm := not FirstStart;
end;

procedure TMainForm.Nastaven1Click(Sender: TObject);
begin
  CoolTrayIcon1.ShowMainForm;
end;

function TMainForm.GetShareUnblockFirewall: Boolean;
begin
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\SYSTEM\CurrentControlSet\Services\SharedAccess\Parameters\FirewallPolicy\StandardProfile\GloballyOpenPorts\List', True);
    Result := (ReadString('137:UDP') = '137:UDP:'+LocalNetAddr+'/'+LocalNetMask+':Enabled:@xpsp2res.dll,-22001')
      and (ReadString('138:UDP') = '138:UDP:'+LocalNetAddr+'/'+LocalNetMask+':Enabled:@xpsp2res.dll,-22002')
      and (ReadString('139:TCP') = '139:TCP:'+LocalNetAddr+'/'+LocalNetMask+':Enabled:@xpsp2res.dll,-22004')
      and (ReadString('445:TCP') = '445:TCP:'+LocalNetAddr+'/'+LocalNetMask+':Enabled:@xpsp2res.dll,-22005');
  finally
    Free;
  end;
end;

procedure TMainForm.SetShareUnblockFirewall(const Value: Boolean);
begin
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\SYSTEM\CurrentControlSet\Services\SharedAccess\Parameters\FirewallPolicy\StandardProfile\GloballyOpenPorts\List', True);
    if Value then begin
      WriteString('137:UDP', '137:UDP:'+LocalNetAddr+'/'+LocalNetMask+':Enabled:@xpsp2res.dll,-22001');
      WriteString('138:UDP', '138:UDP:'+LocalNetAddr+'/'+LocalNetMask+':Enabled:@xpsp2res.dll,-22002');
      WriteString('139:TCP', '139:TCP:'+LocalNetAddr+'/'+LocalNetMask+':Enabled:@xpsp2res.dll,-22004');
      WriteString('445:TCP', '445:TCP:'+LocalNetAddr+'/'+LocalNetMask+':Enabled:@xpsp2res.dll,-22005');
    end else begin
      WriteString('137:UDP', '137:UDP:LocalSubNet:Enabled:@xpsp2res.dll,-22001');
      WriteString('138:UDP', '138:UDP:LocalSubNet:Enabled:@xpsp2res.dll,-22002');
      WriteString('139:TCP', '139:TCP:LocalSubNet:Enabled:@xpsp2res.dll,-22004');
      WriteString('445:TCP', '445:TCP:LocalSubNet:Enabled:@xpsp2res.dll,-22005');
    end;
  finally
    Free;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  SaveOptions;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  CheckBox4.Checked := True;
  CheckBox5.Checked := True;
  CheckBox6.Checked := True;
  CheckBox9.Checked := True;
end;

procedure TMainForm.Oprogramu1Click(Sender: TObject);
begin
  AboutWindow.ShowModal;
end;

function TMainForm.GetNetSharedFolder: Boolean;
var
  PShareInfo: PShareInfo2;
begin
  Result := False;
  NetShareGetInfo(nil, MainSharedFolderName, 2, @PShareInfo);
  if Assigned(PShareInfo) then begin
    Result := PShareInfo.shi2_path = MainSharedFolderPath;
    NetApiBufferFree(PShareInfo);
  end;
end;

procedure TMainForm.SetNetSharedFolder(const Value: Boolean);
var
  Err: Cardinal;
  ShareInfo: TShareInfo2;
begin
  if Value then begin
    if not DirectoryExists(MainSharedFolderPath) then ForceDirectories(MainSharedFolderPath);
    with ShareInfo do begin
      shi2_netname := MainSharedFolderName;
      shi2_path := MainSharedFolderPath;
      shi2_permissions := ACCESS_ALL;
      shi2_remark := '';
      shi2_type := STYPE_DISKTREE;
      shi2_max_uses := High(Cardinal);
      shi2_passwd := '';
    end;
    NetShareAdd(nil, 2, @ShareInfo, Err);
  end else begin
    NetShareDel(nil, MainSharedFolderName, 0);
  end;
end;

procedure TMainForm.Init;
var
  Hostname: string;
begin
  HostName := 'default';

  //DefaultGateway := GetDefaultGateway;
  //if AutoDial then Dial;
end;

function GetIPFromHost(var HostName, IPaddr, WSAErr: string): Boolean;
type
  Name = array[0..100] of Char;
  PName = ^Name;
var 
  HEnt: pHostEnt;
  HName: PName; 
  WSAData: TWSAData; 
  i: Integer; 
begin 
  Result := False;
  if WSAStartup($0101, WSAData) <> 0 then begin 
    WSAErr := 'Winsock is not responding."'; 
    Exit; 
  end; 
  IPaddr := ''; 
  New(HName); 
  if GetHostName(HName^, SizeOf(Name)) = 0 then
  begin 
    HostName := StrPas(HName^); 
    HEnt := GetHostByName(HName^); 
    for i := 0 to HEnt^.h_length - 1 do 
     IPaddr :=
      Concat(IPaddr,
      IntToStr(Ord(HEnt^.h_addr_list^[i])) + '.');
    SetLength(IPaddr, Length(IPaddr) - 1);
    Result := True;
  end
  else begin
   case WSAGetLastError of
    WSANOTINITIALISED:WSAErr:='WSANotInitialised'; 
    WSAENETDOWN      :WSAErr:='WSAENetDown'; 
    WSAEINPROGRESS   :WSAErr:='WSAEInProgress'; 
   end; 
  end; 
  Dispose(HName); 
  WSACleanup; 
end;

procedure TMainForm.LoadOptions;
begin
  with TRegistry.Create do
    try
      RootKey := RegistryRootKey;
      OpenKey(RegistryPath, True);
      if ValueExists('FirstStart') then FirstStart := ReadBool('FirstStart')
        else FirstStart := False;
      if ValueExists('NetworkTestLastUpdate') then NetworkTestLastUpdate := StrToDate(ReadString('NetworkTestLastUpdate'));
      if ValueExists('PingTimeout') then PingTimeout := ReadInteger('PingTimeout')
        else PingTimeout := 200;
    finally
      Free;
    end;
end;

procedure TMainForm.SaveOptions;
begin
  with TRegistry.Create do
    try
      RootKey := RegistryRootKey;
      OpenKey(RegistryPath, True);
      WriteBool('FirstStart', True);
      WriteString('NetworkTestLastUpdate', DateToStr(NetworkTestLastUpdate));
      WriteInteger('PingTimeout', PingTimeout);
    finally
      Free;
    end;
end;

function TMainForm.GetNetworkDomain: string;
var
  Command: TDosCommand;
  I: Integer;
  Lines2: TStringList;
begin
  Lines2 := TStringList.Create;
  Result := '';
  Command := TDosCommand.Create(nil);
  with Command do try
    CommandLine := 'ipconfig /all';
    OutputLines := Lines2;
    Execute2;
    for I := 0 to Lines2.Count - 1 do
      if Pos('Prohledvac seznam ppon DNS', Lines2[I]) > 0 then
        Result := Copy(Lines2[I], Pos(':', Lines2[I]) + 2, 255);
  finally
    Free;
    Lines2.Free;
  end;
end;

end.
